<?php
/*
Plugin Name: NBC UserAdvManager
Version: 1.0.b
Description: Permet de renforcer les possibilits de gestion des utilisateurs.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=216
Author: Nicco
Author URI: http://gallery-nicco.no-ip.org
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('NBC_UserAdvManager_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');



/* administration du plugin */
add_event_handler('get_admin_plugin_menu_links', 'NBC_UserAdvManager_admin_menu');

function NBC_UserAdvManager_admin_menu($menu)
{
  array_push($menu,
    array(
      'NAME' => 'UserAdvManager',
      'URL'  => get_admin_plugin_menu_link(NBC_UserAdvManager_PATH.'/admin/UserAdvManager_admin.php')
    )
  );

  return $menu;
}



/* creation de user */
add_event_handler('register_user', 'UserAdvManager_Adduser');

function UserAdvManager_Adduser($register_user)
{
  global $conf;
  
  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  if ( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true' )
  {
    include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
    include(get_language_filepath('plugin.lang.php', NBC_UserAdvManager_PATH));

    $infos = array
    (
      get_l10n_args('User: %s', $register_user['username']),
      get_l10n_args('Password: %s', $_POST['password']),
      get_l10n_args('Email: %s', $register_user['email']),
      get_l10n_args('', ''),
     );

    pwg_mail(
      $register_user['email'],
      array(
        'subject' => '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Add of %s', $register_user['username'])),
        'content' => l10n_args($infos)."\n\n".get_absolute_root_url()
      )
    );
  }
}



/* suppression de user */
//add_event_handler('delete_user', 'UserAdvManager_Deluser');

function UserAdvManager_Deluser($user_id)
{


}



add_event_handler('init', 'UserAdvManager_InitPage');
 
function UserAdvManager_InitPage()
{
  global $conf, $template, $page;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

  include(get_language_filepath('plugin.lang.php', NBC_UserAdvManager_PATH));
  
  
 
/* identification de user */
  if (script_basename() == 'identification')
  {
    if (isset($_POST['login']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true' )
      {
        $query = "
          SELECT ".$conf['user_fields']['username']."
          FROM ".USERS_TABLE."
          WHERE LOWER(".$conf['user_fields']['username'].") = '".strtolower($_POST['username'])."'
        ;";
        list($username) = mysql_fetch_row(pwg_query($query));
  
        if (isset($username))
          $_POST['username'] = $username;
      }
    }
  }



/* identification de user */
  if (script_basename() == 'admin' and $_GET['page'] == 'user_list')
  {
    if (isset($_POST['submit_add']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true' )
      {
        $query = "
          SELECT ".$conf['user_fields']['username']."
          FROM ".USERS_TABLE."
          WHERE LOWER(".$conf['user_fields']['username'].") = '".strtolower($_POST['login'])."'
        ;";
        list($username) = mysql_fetch_row(pwg_query($query));
  
        if (isset($username))
          $_POST['login'] = $username;
      }



      /* adresse mail obligatoire */
      if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' and empty($_POST['email']))
      {
        $lang['reg_err_mail_address'] = 'l\'adresse e-mail est obligatoire et ne peut pas tre vide.<br>';

        $_POST['email'] = '<eMail  saisir>';
      }



      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['email']))
      {
        $query = '
          SELECT COUNT('.$conf['user_fields']['id'].')
          FROM '.USERS_TABLE.'
          WHERE '.$conf['user_fields']['email'].' = \''.$_POST['email'].'\'
        ;';
        list($nbr_mail) = mysql_fetch_row(pwg_query($query));
      
        if (isset($nbr_mail) and $nbr_mail > 0)
        {
          $lang['reg_err_mail_address'] = 'l\'adresse e-mail saisie est dj prise par un autre utilisateur, si c\'est bien la votre : utilisez la fonction Mot de Passe oubli pour recevoir sur cette email un nouveau mot de passe.';

          $_POST['email'] = '<eMail dj utilis>';
        }
      }

    }
  }



/* creation OU mise a jour de user */
  if (in_array(script_basename(), array('register', 'profile')))
  {
    if (isset($_POST['submit']) or isset($_POST['validate']))
    {
      /* adresse mail obligatoire */
      if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' and empty($_POST['mail_address']))
      {
        $lang['reg_err_mail_address'] = 'l\'adresse e-mail est obligatoire et ne peut pas tre vide.<br>';

        $_POST['mail_address'] = '<eMail  saisir>';
      }
    }
  }



/* creation de user */
  if (script_basename() == 'register')
  {
    if (isset($_POST['submit']))
    {
      /* username insensible a la casse */
      if (isset($conf_nbc_UserAdvManager[3]) and $conf_nbc_UserAdvManager[3] == 'true')
      {
        $query = "
          SELECT ".$conf['user_fields']['username']."
          FROM ".USERS_TABLE."
          WHERE LOWER(".$conf['user_fields']['username'].") = '".strtolower($_POST['login'])."'
        ;";
        list($username) = mysql_fetch_row(pwg_query($query));
      
        if (isset($username))
          $_POST['login'] = $username;
      }



      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['mail_address']))
      {
        $query = '
          SELECT COUNT('.$conf['user_fields']['id'].')
          FROM '.USERS_TABLE.'
          WHERE '.$conf['user_fields']['email'].' = \''.$_POST['mail_address'].'\'
        ;';
        list($nbr_mail) = mysql_fetch_row(pwg_query($query));
      
        if (isset($nbr_mail) and $nbr_mail > 0)
        {
          $lang['reg_err_mail_address'] = 'l\'adresse e-mail saisie est dj prise par un autre utilisateur, si c\'est bien la votre : utilisez la fonction Mot de Passe oubli pour recevoir sur cette email un nouveau mot de passe.';

          $_POST['mail_address'] = '<eMail dj utilis>';
        }
      }
    }
  }



/* mise a jour de user */
  if (script_basename() == 'profile')
  {
    if (isset($_POST['validate']))
    {
      /* adresse mail unique */
      if (isset($conf_nbc_UserAdvManager[2]) and $conf_nbc_UserAdvManager[2] == 'true' and !empty($_POST['mail_address']))
      {
        $query = '
          SELECT '.$conf['user_fields']['id'].'
          FROM '.USERS_TABLE.'
          WHERE '.$conf['user_fields']['email'].' = \''.$_POST['mail_address'].'\'
        ;';
        list($user_id) = mysql_fetch_row(pwg_query($query));
      
        if (isset($user_id) and $_POST['userid'] != $user_id)
        {
          $lang['reg_err_mail_address'] = 'l\'adresse e-mail saisie est dj prise par un autre utilisateur, si c\'est bien la votre : utilisez la fonction Mot de Passe oubli pour recevoir sur cette email un nouveau mot de passe.';
        
          $_POST['mail_address'] = '<eMail dj utilis>';
        }
      }



      if ( isset($conf_nbc_UserAdvManager[0]) and $conf_nbc_UserAdvManager[0] == 'true' )
      {
        $errors = array();
  
        $int_pattern = '/^\d+$/';
        if (empty($_POST['nb_image_line'])
            or (!preg_match($int_pattern, $_POST['nb_image_line'])))
        {
          $errors[] = l10n('nb_image_line_error');
        }
      
        if (empty($_POST['nb_line_page'])
            or (!preg_match($int_pattern, $_POST['nb_line_page'])))
        {
          $errors[] = l10n('nb_line_page_error');
        }
      
        if ($_POST['maxwidth'] != ''
            and (!preg_match($int_pattern, $_POST['maxwidth'])
                 or $_POST['maxwidth'] < 50))
        {
          $errors[] = l10n('maxwidth_error');
        }
        if ($_POST['maxheight']
             and (!preg_match($int_pattern, $_POST['maxheight'])
                   or $_POST['maxheight'] < 50))
        {
          $errors[] = l10n('maxheight_error');
        }
        // periods must be integer values, they represents number of days
        if (!preg_match($int_pattern, $_POST['recent_period'])
            or $_POST['recent_period'] <= 0)
        {
          $errors[] = l10n('periods_error') ;
        }
      
        if (isset($_POST['mail_address']))
        {
          $mail_error = validate_mail_address($_POST['mail_address']);
          if (!empty($mail_error))
          {
            $errors[] = $mail_error;
          }
        }
      
        if (!empty($_POST['use_new_pwd']))
        {
          // password must be the same as its confirmation
          if ($_POST['use_new_pwd'] != $_POST['passwordConf'])
          {
            $errors[] = l10n('New password confirmation does not correspond');
          }
      
          if ( !defined('IN_ADMIN') )
          {// changing password requires old password
            $query = '
              SELECT '.$conf['user_fields']['password'].' AS password
              FROM '.USERS_TABLE.'
              WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
            ;';
            list($current_password) = mysql_fetch_row(pwg_query($query));
        
            if ($conf['pass_convert']($_POST['password']) != $current_password)
            {
              $errors[] = l10n('Current password is wrong');
            }
          }
        }
      
        if (count($errors) == 0)
        {
          include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
  
          $query = '
            SELECT '.$conf['user_fields']['username'].'
            FROM '.USERS_TABLE.'
            WHERE '.$conf['user_fields']['id'].' = \''.$_POST['userid'].'\'
          ;';
          list($username) = mysql_fetch_row(pwg_query($query));
  
          $infos = array
          (
            get_l10n_args('User: %s', $username),
            get_l10n_args('Password: %s', $_POST['use_new_pwd']),
            get_l10n_args('Email: %s', $_POST['mail_address']),
            get_l10n_args('', ''),
           );
      
          pwg_mail(
            $_POST['mail_address'],
            array(
              'subject' => '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Update of %s', $username)),
              'content' => l10n_args($infos)."\n\n".get_absolute_root_url()
            )
          );
        }
      }
    }
  }
}



add_event_handler('loc_begin_tpl_parse', 'ChangeRegisterProfilePage');

function ChangeRegisterProfilePage()
{
  global $conf, $template;

  $conf_nbc_UserAdvManager = isset($conf['nbc_UserAdvManager']) ? explode(";" , $conf['nbc_UserAdvManager']) : array();

/* creation OU mise a jour de user */
  if (in_array(script_basename(), array('register', 'profile')))
  {
    if (isset($conf_nbc_UserAdvManager[1]) and $conf_nbc_UserAdvManager[1] == 'true' )
    {
      $template->set_filenames( array('register'=>'register.tpl') );
      
      personal_add_before_tpl_code('register', '{lang:Mail address}', '* ');
    }
  }
}
    



?>
